function SetPersonValue(person, key, value)
{ 
  var person_data = GetPersonData(person);
  person_data[key] = value;
  SetPersonData(person, person_data);
}

function FlipPerson(name) {
  var spriteset = GetPersonSpriteset(name);
  for (var i = 0; i < spriteset.images.length; i++) {
    var surface = spriteset.images[i].createSurface();
    surface.flipVertically();
    spriteset.images[i] = surface.createImage();
  }
  SetPersonSpriteset(name, spriteset);
}

function UpdateScript()
{
  var person = GetInputPerson();
  var person_data = GetPersonData(person);

  if (person_data["gravity"] > 0) {
    QueuePersonCommand(person, COMMAND_MOVE_SOUTH, true);
  }
  else if (person_data["gravity"] < 0) {
    QueuePersonCommand(person, COMMAND_MOVE_NORTH, true);
  }
  
  if (IsKeyPressed(KEY_UP) && person_data["gravity"] > 0) {
    FlipPerson(person);
    SetPersonValue(person, "gravity", -1);
  }

  if (IsKeyPressed(KEY_DOWN) && person_data["gravity"] < 0) {
    FlipPerson(person);
    SetPersonValue(person, "gravity", 1);
  }
  
  if (IsKeyPressed(KEY_LEFT)) {
    QueuePersonCommand(person, COMMAND_MOVE_WEST, true);  
  }

  if (IsKeyPressed(KEY_RIGHT)) {
    QueuePersonCommand(person, COMMAND_MOVE_EAST, true);  
  }
}

function game()
{
  CreatePerson("player", "ninja.rss", false);
  AttachInput("player");
  AttachCamera("player");

  SetUpdateScript("UpdateScript()");

  SetPersonSpeedXY("player", 1, 2);
  SetPersonValue("player", "gravity", 1);

  MapEngine("digestive.rmp", 60);
}
